/*!
 * @file glgui_imagebutton.h
 *
 */

#ifndef _GLGUI_IMAGEBUTTON_H
#define _GLGUI_IMAGEBUTTON_H

#include "glgui_pushbutton.h"
#include "event_listener.h"

#include "glgui_image.h"

//! Namespace of the GLGuiImageButton of ORXONOX.
namespace OrxGui
{
  class GLGuiImageButton : public GLGuiPushButton
  {
  public:
    GLGuiImageButton(const std::string& label, unsigned int levelID, const std::string& imageName, GLGuiImage* image);
    virtual ~GLGuiImageButton();


    void push();
    void release();

    DeclareSignal1(startLevel, int);

  protected:
    virtual void releasing(const Vector2D& pos, bool focused);
    virtual void receivedFocus();
    virtual void removedFocus();

    virtual void showing();
    virtual void hiding();

    virtual bool processEvent(const Event& event);
  private:
    unsigned int        levelID;
    std::string         imageName;
    GLGuiImage*         image;

  private:

  };

}

#endif /* _GLGUI_IMAGEBUTTON_H */
