/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GAME_RULES

#include "mission_goal.h"
#include "game_rules.h"

#include "state.h"
#include "util/loading/load_param.h"

using namespace std;


/**
 * standard constructor
 * @todo this constructor is not jet implemented - do it
*/
MissionGoal::MissionGoal (const TiXmlElement* root)
{
   this->setClassID(CL_MISSION_GOAL, "MissionGoal");

   this->missionState = MS_PASSIVE;
   // add the mission to the current game rule
   GameRules* gr = State::getGameRules();
   if( gr)
     gr->addMissionGoal(this);

   if( root != NULL)
     this->loadParams(root);
}


/**
 * standard deconstructor
*/
MissionGoal::~MissionGoal ()
{

}

/**
 * loading parameter function: more help on the wiki pages
 */
void MissionGoal::loadParams(const TiXmlElement* root)
{
  BaseObject::loadParams(root);

  LoadParam(root, "title", this, MissionGoal, setMissionName)
      .describe("sets the title of the mission");
  LoadParam(root, "description", this, MissionGoal, setMissionDescription)
      .describe("sets the mission description");
}

